
/* Chrysalide - Outil d'analyse de fichiers binaires
 * assign.h - prototypes pour la représentation des assignations
 *
 * Copyright (C) 2010-2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_ASSIGN_H
#define _DECOMP_EXPR_ASSIGN_H


#include <glib-object.h>


#include "../expression.h"
#include "../instruction.h"



#define G_TYPE_ASSIGN_EXPRESSION               g_assign_expression_get_type()
#define G_ASSIGN_EXPRESSION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_assign_expression_get_type(), GAssignExpression))
#define G_IS_ASSIGN_EXPRESSION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_assign_expression_get_type()))
#define G_ASSIGN_EXPRESSION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_ASSIGN_EXPRESSION, GAssignExpressionClass))
#define G_IS_ASSIGN_EXPRESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_ASSIGN_EXPRESSION))
#define G_ASSIGN_EXPRESSION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_ASSIGN_EXPRESSION, GAssignExpressionClass))



/* Définition d'une assignation quelconque (instance) */
typedef struct _GAssignExpression GAssignExpression;

/* Définition d'une assignation quelconque (classe) */
typedef struct _GAssignExpressionClass GAssignExpressionClass;


/* Indique le type défini pour une assignation quelconque. */
GType g_assign_expression_get_type(void);

/* Assigne le contenu d'une expression dans une autre. */
GDecInstruction *g_assign_expression_new(GDecExpression *, GDecExpression *);

/* Indique la destination d'une assignation. */
GDecExpression *g_assign_expression_get_dest(const GAssignExpression *);

/* Indique la source d'une assignation. */
GDecExpression *g_assign_expression_get_src(const GAssignExpression *);



#endif  /* _DECOMP_EXPR_ASSIGN_H */
